//******************************************************************************
// Calendar.java:	Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.util.*;


//==============================================================================
// Main Class for applet Calendar
//
//==============================================================================
public class Calendar extends Applet implements Runnable
{
	// THREAD SUPPORT:
	//		m_Calendar	is the Thread object for the applet
	//--------------------------------------------------------------------------
	Thread	 m_Calendar = null;
	CalendarLayout dlg;

	// Calendar Class Constructor
	//--------------------------------------------------------------------------
	public Calendar()	{
		// TODO: Add constructor code here
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    //--------------------------------------------------------------------------
	public String getAppletInfo()	{
		return "Name: Calendar\r\n" +
		       "Author: Unknown\r\n" +
		       "Created with Microsoft Visual J++ Version 1.0";
	}

	//today
	public Date today = new Date();

	// current month number
	public int todayMonth=today.getMonth();

	// current year number
	public int todayYear=today.getYear();

	// current date number
	public int todayDate=today.getDate();

	// current day number
	public int todayDay=today.getDay();

	private String	MonthNames[] = {"January", "February", "March", "April", "May",
		"June", "July", "August", "September", "October", "November", "December"};;

	public int monthModifier = todayMonth;

	public int yearModifier = todayYear;


	  
  
	// The init() method is called by the AWT when an applet is first loaded or
	// reloaded.  Override this method to perform whatever initialization your
	// applet needs, such as initializing data structures, loading images or
	// fonts, creating frame windows, setting the layout manager, or adding UI
	// components.
    //--------------------------------------------------------------------------
	public void init()	{
		setLayout(new FlowLayout());
		dlg = new CalendarLayout( this );
		dlg.CreateControls();
		Date thisMonth = new Date( todayYear, todayMonth, 1 );
		setCalendarDays( thisMonth );

	}

	// Place additional applet clean up code here.  destroy() is called when
	// when you applet is terminating and being unloaded.
	//-------------------------------------------------------------------------
	public void destroy()	{
		// TODO: Place applet cleanup code here
	}

	// Calendar Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)	{
		// TODO: Place applet paint code here
		// g.drawString("Running: " + Math.random(), 10, 20);
	}

	//		The start() method is called when the page containing the applet
	// first appears on the screen. The AppletWizard's initial implementation
	// of this method starts execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void start()	{
		if (m_Calendar == null)
		{
			m_Calendar = new Thread(this);
			m_Calendar.start();
		}
		// TODO: Place additional applet start code here
	}
	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop()	{
		if (m_Calendar != null)
		{
			m_Calendar.stop();
			m_Calendar = null;
		}

		// TODO: Place additional applet stop code here
	}

	


	// Sets the days on the Calendar layout
	public void setCalendarDays( Date DateChoice )	{

			// current month number
			int selectedMonth=DateChoice.getMonth();

			// current year number
			int selectedYear=DateChoice.getYear();

			// current date number
			int selectedDate=DateChoice.getDate();

			// First day of the month number
			int firstDay = DateChoice.getDay();

			// work out when the month actually ends...
			int nyear, nmonth ;
			if (selectedMonth == 11) {		// jump year
				nyear = selectedYear + 1 ; nmonth = 0 ;
			} else {
				nyear = selectedYear ; nmonth = selectedMonth+1  ;
			}
			Date limitdate = new Date(nyear, nmonth, 1) ;

			// start setting labels
			dlg.label_month.setLabel( MonthNames[selectedMonth] );
			dlg.label_year.setLabel( Integer.toString(selectedYear+1900) );
			int dloop=1;
			Graphics g;
			for (int bloop=0; bloop<42; bloop++) {
				// break out when hit next month
				Date d = new Date(selectedYear, selectedMonth, dloop) ;
				if (! d.before(limitdate)) break ;

				//label day buttons
				if (bloop >= firstDay ) {
					dlg.button_day[bloop].setLabel( Integer.toString(dloop) );
					dlg.button_day[bloop].setColor( Color.lightGray, Color.black  );
					// check for today
					if (dloop==todayDate && selectedMonth==todayMonth) {
						dlg.button_day[bloop].setColor( Color.black, Color.white  );
					}		
					dloop++;
				} else {
			   		dlg.button_day[bloop].setLabel( " " );
			   		dlg.button_day[bloop].setColor( Color.white, Color.black  );
				}
	
			}
			for (int floop=(dloop+firstDay-1); floop<42; floop++) {
			   		dlg.button_day[floop].setLabel( " " );
			   		dlg.button_day[floop].setColor( Color.white, Color.black  );
			}
	}

	public boolean handleEvent(Event evt) {
		switch(evt.id) {
			case Event.WINDOW_DESTROY:
				System.exit(3);
			case Event.MOUSE_DOWN:
			/// output to error log who called 
				System.err.println("Handle Event Target: "+evt.target);
				/// deal with who called
				if (evt.target == dlg.button_nextmonth || evt.target == dlg.label_month) {
						if (monthModifier == 11) {
							yearModifier++;
							monthModifier=0;
						} else {
							monthModifier++;
						}
						Date nextMonth = new Date( yearModifier, monthModifier, 1 );
						setCalendarDays( nextMonth );
						return true;
				} else if ( evt.target == dlg.button_prevmonth) {
						if (monthModifier == 0) {
							yearModifier--;
							monthModifier=11;
						} else {
							monthModifier--;
						}
						Date prevMonth = new Date( yearModifier, monthModifier, 1 );
						setCalendarDays( prevMonth );
						return true;
				} else if ( evt.target == dlg.label_year) {
						yearModifier++;
						Date nextYear = new Date( yearModifier, monthModifier, 1 );
						setCalendarDays( nextYear );
				}
		}
		return true;
	}



	
	
	
	// THREAD SUPPORT
	//		The run() method is called when the applet's thread is started. If
	// your applet performs any ongoing activities without waiting for user
	// input, the code for implementing that behavior typically goes here. For
	// example, for an applet that performs animation, the run() method controls
	// the display of images.
	//--------------------------------------------------------------------------
	public void run()	{
		while (true)
		{
			try
			{
				repaint();
				// TODO:  Add additional thread-specific code here
				Thread.sleep(50);
			}
			catch (InterruptedException e)
			{
				// TODO: Place exception-handling code here in case an
				//       InterruptedException is thrown by Thread.sleep(),
				//		 meaning that another thread has interrupted this one
				stop();
			}
		}
	}

}