import java.awt.*;

// Datelet is the small one day colorable button
// a String that it puts on the button and
// background color, and foreground color

public class Datelet extends Canvas {
	String DateletLabel;
	Color bg, fg;
	Font ft = new Font( "Helvetica", Font.BOLD, 12 );
	boolean button_up = true;
	
	public Datelet( String D, Color back, Color fore ) {
		bg = back;
		fg = fore;
		DateletLabel = D;
		System.err.println( "Datelet Label: "+D );
	}
	
	public void paint( Graphics g ) {
		int width  = size().width;
		int height = size().height;
		
		// Draw the tile
		g.setColor( !button_up?bg.darker():bg );
		g.fill3DRect(0, 0, width - 1, height - 1, true);
		
		// Draw the text
		g.setFont( ft );
		g.setColor(!button_up?fg.darker():fg);
		
		int h = width / 2;
		int v = height / 3;
		
		FontMetrics fm = g.getFontMetrics();
		h -= fm.stringWidth( DateletLabel ) / 2;
		v += (fm.getMaxAscent() + fm.getMaxDescent()) / 2;
		g.drawString( DateletLabel, h, v );
	}
	
	public void setColor( Color back, Color fore ) {
		bg = back;
		fg = fore;
		repaint();
	}

	public void setLabel( String D ) {
		DateletLabel = D;
		repaint();
	}
	
	public void setFont( Font F ) {
		ft = F;
		repaint();
	}
	
	public void setShape( int x, int y, int w, int h ) {
		reshape(x,y,w,h);
	}
	
	public String getLabel() {
		return DateletLabel;
	}
				
	public boolean mouseDown(Event evt,int x,int y){
		button_up=false;
		repaint();
		return false;
	}
	public boolean mouseUp(Event evt,int x,int y){
		button_up=true;
		repaint();
		return false;
	}
	

	
}